<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "provider_practice_gp".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ProviderPracticeGp".
 *
 * Columns in table "provider_practice_gp" available as properties of the model,
 * followed by relations of table "provider_practice_gp" available as properties of the model.
 *
 * @property integer $id
 * @property integer $practice_id
 * @property integer $provider_id
 * @property string $place_id
 * @property string $date_added
 * @property string $date_updated
 *
 * @property ProviderPractice $provider
 * @property Practice $practice
 */
abstract class BaseProviderPracticeGp extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'provider_practice_gp';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ProviderPracticeGp|ProviderPracticeGps', $n);
    }

    public static function representingColumn()
    {
        return 'date_added';
    }

    public function rules()
    {
        return array(
            array('practice_id, date_updated', 'required'),
            array('practice_id, provider_id', 'numerical', 'integerOnly'=>true),
            array('place_id', 'length', 'max'=>30),
            array('date_added', 'safe'),
            array('provider_id, place_id, date_added', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, practice_id, provider_id, place_id, date_added, date_updated', 'safe', 'on'=>'search'),
        );
    }

    public function relations()
    {
        return array(
            'provider' => array(self::BELONGS_TO, 'ProviderPractice', 'provider_id'),
            'practice' => array(self::BELONGS_TO, 'Practice', 'practice_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'practice_id' => null,
            'provider_id' => null,
            'place_id' => Yii::t('app', 'Place'),
            'date_added' => Yii::t('app', 'Date Added'),
            'date_updated' => Yii::t('app', 'Date Updated'),
            'provider' => null,
            'practice' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('practice_id', $this->practice_id);
        $criteria->compare('provider_id', $this->provider_id);
        $criteria->compare('place_id', $this->place_id, true);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('date_updated', $this->date_updated, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
